################################################################################
################################################################################
############### COURSERA 3.INDIVIDUAL CONSUMPTION & CERTIFICATE ################
################################################################################
################################################################################

################################################################################################
############################ CONSOMMATION ON INDIVIDUAL LEVEL ##################################
################################################################################################
library(reshape)


### Lecture ###
# preparing table for the cast : 3 col =  subjects, variable, values 
individual_vision_lecture<-lecture_submission_metadata3[lecture_submission_metadata3$action=="view",c("session_user_id","item_id","submission_time")]
colnames(individual_vision_lecture)<-c("user_id","variable","value")
# explode values into columns named by item_id ("variable")
# create unique team in lines
individual_vision_lecture2<-cast(individual_vision_lecture,user_id ~ variable) # 2646 lines
individual_vision_lecture2$nb_lecture_unique<-NA
for (i in 1:nrow(individual_vision_lecture2)){
  individual_vision_lecture2$nb_lecture_unique[i]<- length(individual_vision_lecture2[i,which(individual_vision_lecture2[i,2:(ncol(individual_vision_lecture2)-1)]>0)])
}
a<-individual_vision_lecture2[individual_vision_lecture2$nb_lecture_unique>=45,]
table(individual_vision_lecture2$nb_lecture_unique)
hist(individual_vision_lecture2$nb_lecture_unique,breaks=46)
#test<-seq(1,length(table(individual_vision_lecture2$nb_lecture_unique)))


############ QUIZ ###
individual_vision_quiz<-quiz_submission_metadata3[,c("session_user_id","item_id","submission_time")]
colnames(individual_vision_quiz)<-c("user_id","variable","value")
# explode values into columns named by item_id ("variable")
# create unique team in lines
individual_vision_quiz2<-cast(individual_vision_quiz,user_id ~ variable) # 1191 lines
# test<-individual_vision_quiz2[which(individual_vision_quiz2>1)==1,]
individual_vision_quiz2$nb_quiz_unique<-NA
for (i in 1:nrow(individual_vision_quiz2)){
  individual_vision_quiz2$nb_quiz_unique[i]<- length(individual_vision_quiz2[i,which(individual_vision_quiz2[i,2:(ncol(individual_vision_quiz2)-1)]>0)])
}
table(individual_vision_quiz2$nb_quiz_unique)
hist(individual_vision_quiz2$nb_quiz_unique)


####### ASSIGNMENT ###
# preparing table for the cast : 3 col =  subjects, variable, values 
individual_vision_assignment<-assignment_submission_metadata3[,c("session_user_id","assignment_id","submission_time")]
colnames(individual_vision_assignment)<-c("user_id","variable","value")
# explode values into columns named by item_id ("variable")
# create unique team in lines
individual_vision_assignment2<-cast(individual_vision_assignment,user_id ~ variable) 
individual_vision_assignment2$nb_assignment_unique<-NA
for (i in 1:nrow(individual_vision_assignment2)){
  individual_vision_assignment2$nb_assignment_unique[i]<- length(individual_vision_assignment2[i,which(individual_vision_assignment2[i,2:(ncol(individual_vision_assignment2)-1)]>0)])
}
table(individual_vision_assignment2$nb_assignment_unique)
hist(individual_vision_assignment2$nb_assignment_unique,breaks=46)

save.image(paste0(mooc,"_post_consumption_analysis.RData"))
load(paste0(mooc,"_post_consumption_analysis.RData"))


###################################################################
############# CERTIFICATE, GRADES ANALYSIS ########################
###################################################################

#merge users and grade
students<-merge(students,course_grades,by="session_user_id",all.x=T)

nb_lecture<-length(unique(individual_vision_lecture$variable[is.na(individual_vision_lecture$variable)==F ]))
individual_vision_lecture2$pc_lecture<-round(individual_vision_lecture2$nb_lecture_unique*100/nb_lecture,2)
individual_vision_lecture2<-merge(individual_vision_lecture2,students[,c("session_user_id","achievement_level")],by.x="user_id",by.y="session_user_id",all.x=T)

nb_quiz<-length(unique(individual_vision_quiz$variable[is.na(individual_vision_quiz$variable)==F ]))
individual_vision_quiz2$pc_quiz<-round(individual_vision_quiz2$nb_quiz_unique*100/nb_quiz,2)
summary(individual_vision_quiz2$pc_quiz)
individual_vision_quiz2<-merge(individual_vision_quiz2,students[,c("session_user_id","achievement_level")],by.x="user_id",by.y="session_user_id",all.x=T)

nb_assignment<-length(unique(individual_vision_assignment$variable[is.na(individual_vision_assignment$variable)==F ]))
individual_vision_assignment2$pc_assignment<-round(individual_vision_assignment2$nb_assignment_unique*100/nb_assignment,2)
summary(individual_vision_assignment2$pc_assignment)
individual_vision_assignment2<-merge(individual_vision_assignment2,students[,c("session_user_id","achievement_level")],by.x="user_id",by.y="session_user_id",all.x=T)


#Breslow figure 4
table(course_grades$achievement_level)
# algoprog1
# distinction        none      normal 
# 126        8699         120 
# algoprog2
# distinction        none      normal
# 107        6198          26 
#distinction certification
nb_certif<-length(course_grades$achievement_level[course_grades$achievement_level=="distinction"])
lec<-(cumsum(table(individual_vision_lecture2$pc_lecture[individual_vision_lecture2$achievement_level=="distinction"])))*100/nb_certif
lecture<-c(100,100-lec)
names(lecture)<-c("0",names(lec))
qui<-(cumsum(table(individual_vision_quiz2$pc_quiz[individual_vision_quiz2$achievement_level=="distinction"])))*100/nb_certif
quiz<-c(100,100-qui)
names(quiz)<-c("0",names(qui))
ass<-(cumsum(table(individual_vision_assignment2$pc_assignment[individual_vision_assignment2$achievement_level=="distinction"])))*100/nb_certif
assignment<-c(100,100-ass)
names(assignment)<-c("0",names(ass))

# graph for distinction certification
png(paste0(out,"activ temp/certif distinction.png"), temp.width,temp.height, pointsize = 15)
plot(names(lecture),lecture,xlab="%R - pourcentage de ressources pédagogiques utilisées",ylab="%N de certifiés avec distinction accédant à > %R Ressources",type="l",col="dark red", cex.lab=1)#,main="Lecture"
text(75,60,"Vidéos",col="dark red") #a la main
points(names(lecture)[18],lecture[18],col="dark red")
lines(names(quiz),quiz,col="blue")
text(75,35,"Quiz",col="blue") #a la main
lines(names(assignment),assignment,col="forestgreen")
text(75,80,"Devoirs",col="forestgreen") #a la main
dev.off()


#normal certification
nb_certif<-length(course_grades$achievement_level[course_grades$achievement_level=="normal"])
lec<-(cumsum(table(individual_vision_lecture2$pc_lecture[individual_vision_lecture2$achievement_level=="normal"])))*100/nb_certif
lecture<-c(100,100-lec)
names(lecture)<-c("0",names(lec))
qui<-(cumsum(table(individual_vision_quiz2$pc_quiz[individual_vision_quiz2$achievement_level=="normal"])))*100/nb_certif
quiz<-c(100,100-qui)
names(quiz)<-c("0",names(qui))
ass<-(cumsum(table(individual_vision_assignment2$pc_assignment[individual_vision_assignment2$achievement_level=="normal"])))*100/nb_certif
assignment<-c(100,100-ass)
names(assignment)<-c("0",names(ass))

# graph for normal certification
png(paste0(out,"activ temp/certif normal.png"), temp.width,temp.height, pointsize = 15)
plot(names(lecture),lecture,xlab="%R - pourcentage de ressources pédagogiques utilisées",ylab="%N de certifiés normaux accédant à > %R Ressources",type="l",col="dark red", cex.lab=1)#,main="Lecture"
points(names(lecture)[8],lecture[8],col="dark red")
text(50,70,"Vidéo",col="dark red") #a la main
lines(names(quiz),quiz,col="blue")
text(40,60,"Quiz",col="blue") #a la main
lines(names(assignment),assignment,col="forestgreen")
text(60,80,"Devoirs",col="forestgreen") #a la main
dev.off()

#distinction + normal
nb_certif<-length(course_grades$achievement_level[course_grades$achievement_level=="normal" | course_grades$achievement_level=="distinction"])
lec<-(cumsum(table(individual_vision_lecture2$pc_lecture[individual_vision_lecture2$achievement_level=="distinction"|individual_vision_lecture2$achievement_level=="normal"])))*100/nb_certif
lecture<-c(100,100-lec)
names(lecture)<-c("0",names(lec))
qui<-(cumsum(table(individual_vision_quiz2$pc_quiz[individual_vision_quiz2$achievement_level=="distinction"|individual_vision_quiz2$achievement_level=="normal"])))*100/nb_certif
quiz<-c(100,100-qui)
names(quiz)<-c("0",names(qui))
ass<-(cumsum(table(individual_vision_assignment2$pc_assignment[individual_vision_assignment2$achievement_level=="distinction"|individual_vision_assignment2$achievement_level=="normal"])))*100/nb_certif
assignment<-c(100,100-ass)
names(assignment)<-c("0",names(ass))

# graph for distinction + normal certification
png(paste0(out,"activ temp/certif total.png"), temp.width,temp.height, pointsize = 15)
plot(names(lecture),lecture,xlab="%R - pourcentage de ressources pédagogiques utilisées",ylab="%N de certifiés accédant à > %R Ressources",type="l",col="dark red", cex.lab=1)#,main="Lecture"
text(75,60,"Vidéos",col="dark red") #a la main
points(names(lecture)[18],lecture[18],col="dark red")
lines(names(quiz),quiz,col="blue")
text(75,35,"Quiz",col="blue") #a la main
lines(names(assignment),assignment,col="forestgreen")
text(75,80,"Devoirs",col="forestgreen") #a la main
dev.off()


####################################################################
####### CROSSING CERTIFIATE, GRADES AND BACKGROUND QUESTIONAIRE ####
####################################################################

table(course_grades$achievement_level)
#merge users and background
students2<-merge(students, demographic_responce,by.x="session_user_id",by.y="Session.User.Id",all.x=T) #only nrow(demographic_response)=260 answerer to questionaire

#merge users and grade
#students2<-merge(students2,course_grades,by="session_user_id",all.x=T)


# test<-match(users$session_user_id,hg_assessment_submission_metadata$author_id)
# summary(test)

table(students2$achievement_level)
students2$achievement_level<-as.factor(students2$achievement_level)
levels(students2$Gender)=c("female","male",NA)
students2$schooling<-students2$Highest.Level.Of.Schooling
levels(students2$schooling)<-c("Bac+2","Bac+2","Licence","Doctorat","Bac","Bac+5","Inférieur Bac","Bac","Bac","Inférieur Bac","Inférieur Bac")
lm.1=glm(achievement_level~relevel(Gender,ref="male")+Age+relevel(Continent,ref="Europe")+relevel(schooling,ref="Bac")+relevel(Current.Employment.Status,ref="employed full-time (35 or more hours per week)"), data = students2, family = "binomial") 
#HDI+sexe+section+edu+csp.agriculteur+csp.artisant+csp.intermediaire+csp.employe+csp.ouvrier+csp.retraite+csp.etudiant+csp.jobseeker+csp.Inactive+csp.intellectuel
summary(lm.1)
anova(lm.1)

library("foreign")
library("nnet")
library("ggplot2")
library("reshape2")
students2$achievement_level2 <- relevel(students2$achievement_level, ref = "none")
#chaque niveau est comparé à la ref => normal versus non certif puis distinction versus non certif
lm.1=multinom(achievement_level2~relevel(Gender,ref="male")+Age+relevel(Continent,ref="Europe")+relevel(schooling,ref="Bac")+relevel(Current.Employment.Status,ref="employed full-time (35 or more hours per week)"), data = students2)
summary(lm.1)
z<-summary(lm.1)$coefficients/summary(lm.1)$standard.errors
# 2-tailed z test
#The p-value is less than the generally used criterion of 0.05, so we are able to reject the null hypothesis, indicating that the coefficients is not equal to zero.
p<-(1 - pnorm(abs(z), 0, 1)) * 2

## extract the coefficients from the model and exponentiate
exp(coef(lm.1))
head(pp <- fitted(lm.1))
dses <- data.frame(ses = c("female", "male"), write = mean(students2$Gender))
predict(lm.1, newdata = dses, "probs")

save.image(paste0(mooc,"_avt_pattern.RData"))
load(paste0(mooc,"_avt_pattern.RData"))
