################################################################################
################################################################################
################################################################################
###### COURSERA 6 PATTERN OF ACTIONS BY INDIVIDUAL: exploration of sequences ###
################################################################################
################################################################################
################################################################################


#####################################################################################
################ TraMineR: http://traminer.unige.ch/preview-main.shtml ##############
# http://quanti.hypotheses.org/686/ #
#####################################################################################

library(TraMineR)



##### ATTENTION, CHOIX A FAIRE ENTRE CALENDAIRE ET MODULAIRE #########

# 8 states
# w.alphabet<-c("assignment","download","Inactive","quiz","redownload", "requiz", "review", "view")
# w.labels<-c("assignment","download","Inactive","quiz","redownload", "requiz", "review", "view")
# w.scodes<-c("A","D","I","Q","RD","RQ","RV","V")

# 5 states
w.alphabet<-c("assignment","download","Inactive","quiz","view")
w.labels<-c("assignment","download","Inactive","quiz","view")
w.scodes<-c("A","D","I","Q","V")

# 5 états => action_unique$action
# 8 états => action_unique$action_bis
act<-"action"
########################################## VISION TEMP A FAIRE EN 1ER
vision<-"temp" 
vision<-"mod"

act_order<-ifelse(vision=="temp","action_order","action_order_mod")

#action_unique2$sub_week #vision calendaire
#action_unique2$open_week #vision modulaire 
if(vision=="temp"){table(action_unique2$sub_week,action_unique2$display_order)}
if(vision=="mod"){table(action_unique2$open_week,action_unique2$display_order)}

for(i in 1:ncol(week_course)){
  #i=1
  semaine<-week_course[1,i]
  num_week<-which(week_course[1,]==semaine)
  column<-ifelse(vision=="temp","sub_week","open_week")
  action_bis<-action_unique2[as.character(action_unique2[,column])==semaine,c("session_user_id",act_order,act)]

  
  w <- reshape(action_bis, 
               timevar = act_order,
               idvar = c("session_user_id"),
               direction = "wide")
  w<-w[,!colnames(w)%in%colnames(w)[grep("NA",colnames(w))]]
  
  w.seq <- seqdef(w, 2:ncol(w), alphabet = w.alphabet, states = w.scodes,labels = w.labels, xtstep = 5, cpal=c("darkgreen","chocolate1","aliceblue","darkorchid","firebrick1"))
  # w.seq <- seqdef(w, 2:ncol(w), alphabet = w.alphabet, states = w.scodes,labels = w.labels, xtstep = 8, cpal=c("black","chocolate1","aliceblue","darkorchid1","gold","cyan","deeppink","firebrick1"))
  a<-as.data.frame(matrix(NA,nrow=nrow(w.seq),ncol=4)) #7 colnames for 8 states
  for(l in 1:4){a[,l]<-as.character(a[,l])} 
  colnames(a)<-c("assignment","download","quiz", "view") #c("assignment","download","quiz","redownload","requiz","review", "view")
  w.seq2<- seqdss(w.seq,with.missing=F)
  w.seq2<-cbind(w$session_user_id,w.seq2)
  for(j in 1:ncol(w.seq2)){w.seq2[,j]<-as.character(w.seq2[,j])}
  
  w.seq3<-as.data.frame(cbind(as.character(w.seq2[,1]),as.character(seqconc(w.seq2[,2:ncol(w.seq2)],sep="-"))))
  colnames(w.seq3)<-c("session_user_id","sequence")
  w.seq3<-cbind(w.seq3,a)
  
  # renommer les états en fonction de ce que contient la séquence
  w.seq3$assignment[w.seq3$session_user_id %in% w.seq3$session_user_id[grep("^A-",w.seq3$sequence)] | w.seq3$session_user_id %in% w.seq3$session_user_id[grep("-A-",w.seq3$sequence)] | w.seq3$session_user_id %in% w.seq3$session_user_id[grep("-A$",w.seq3$sequence)]]<-"A"
  w.seq3$download[w.seq3$session_user_id %in% w.seq3$session_user_id[grep("^D-",w.seq3$sequence)] | w.seq3$session_user_id %in% w.seq3$session_user_id[grep("-D-",w.seq3$sequence)] | w.seq3$session_user_id %in% w.seq3$session_user_id[grep("-D$",w.seq3$sequence)]]<-"D"
  w.seq3$quiz[w.seq3$session_user_id %in% w.seq3$session_user_id[grep("^Q-",w.seq3$sequence)] | w.seq3$session_user_id %in% w.seq3$session_user_id[grep("-Q-",w.seq3$sequence)] | w.seq3$session_user_id %in% w.seq3$session_user_id[grep("-Q$",w.seq3$sequence)]]<-"Q"
  #w.seq3$redownload[w.seq3$session_user_id %in% w.seq3$session_user_id[grep("^RD-",w.seq3$sequence)] | w.seq3$session_user_id %in% w.seq3$session_user_id[grep("-RD-",w.seq3$sequence)] | w.seq3$session_user_id %in% w.seq3$session_user_id[grep("-RQ$",w.seq3$sequence)]]<-"RD"
  #w.seq3$requiz[w.seq3$session_user_id %in% w.seq3$session_user_id[grep("^RQ-",w.seq3$sequence)] | w.seq3$session_user_id %in% w.seq3$session_user_id[grep("-RQ-",w.seq3$sequence)] | w.seq3$session_user_id %in% w.seq3$session_user_id[grep("-RQ$",w.seq3$sequence)]]<-"RQ"
  #w.seq3$review[w.seq3$session_user_id %in% w.seq3$session_user_id[grep("^RV-",w.seq3$sequence)] | w.seq3$session_user_id %in% w.seq3$session_user_id[grep("-RV-",w.seq3$sequence)] | w.seq3$session_user_id %in% w.seq3$session_user_id[grep("-RV$",w.seq3$sequence)]]<-"RV"
  w.seq3$view[w.seq3$session_user_id %in% w.seq3$session_user_id[grep("^V-",w.seq3$sequence)] | w.seq3$session_user_id %in% w.seq3$session_user_id[grep("-V-",w.seq3$sequence)] | w.seq3$session_user_id %in% w.seq3$session_user_id[grep("-V$",w.seq3$sequence)]]<-"V"
  w.seq3[,paste0("seq_finale_",i)]<-paste3(w.seq3$assignment,w.seq3$download,w.seq3$quiz,w.seq3$redownload,w.seq3$requiz,w.seq3$review,w.seq3$view,sep="")
  name<-paste("seq_week",i,sep="_")
  assign(name,w.seq3)
  
}


# On regroupe dans sequence_finale les séquences de chaque semaine/module
sequence_finale<-merge(seq_week_1[,c("session_user_id","seq_finale_1")],seq_week_2[,c("session_user_id","seq_finale_2")],all=T)
sequence_finale<-merge(sequence_finale,seq_week_3[,c("session_user_id","seq_finale_3")],all=T)
sequence_finale<-merge(sequence_finale,seq_week_4[,c("session_user_id","seq_finale_4")],all=T)
sequence_finale<-merge(sequence_finale,seq_week_5[,c("session_user_id","seq_finale_5")],all=T)
sequence_finale<-merge(sequence_finale,seq_week_6[,c("session_user_id","seq_finale_6")],all=T)
sequence_finale<-merge(sequence_finale,seq_week_7[,c("session_user_id","seq_finale_7")],all=T)
sequence_finale<-merge(sequence_finale,seq_week_8[,c("session_user_id","seq_finale_8")],all=T)
sequence_finale<-merge(sequence_finale,seq_week_9[,c("session_user_id","seq_finale_9")],all=T)
sequence_finale[is.na(sequence_finale)]<-"I"


# A posteriori :
# 1. Solver pur => que assignment
# 2. Viewer pur => que V+RV
# 3. Dolwloader pur => D, D+RD, RD...
# 4. Quizzer pur => que Q+RQ
# 
# 6. V+D+Q ; V+Q ; D+Q => action video + quiz => 
# 
# 7. V+Q+A ; D+Q+A ; V+D+Q+A .... => video + quiz + assignment =>
# 
# 8. V+A; D+A ; V+D+A .... => video + assignment
# 
# 9. Inactive sur 1 semaine => reussir à recuperer les sortants d'1 semaine a l'autre

# on remplace les états par ce qui est défini au-dessus
sequence_finale2<-sequence_finale
sequence_finale2[sequence_finale=="A"]<-"Solver"
sequence_finale2[sequence_finale=="D"]<-"Collector" # | sequence_finale=="RD" |sequence_finale=="RDD"
sequence_finale2[sequence_finale=="Q"]<-"Quizzer" # | sequence_finale=="RQ" |sequence_finale=="RQQ"
sequence_finale2[sequence_finale=="V" | sequence_finale=="DV"]<-"Viewer" # | sequence_finale=="RV" |sequence_finale=="RVV"

sequence_finale2[sequence_finale=="DQV" | sequence_finale=="QV" |sequence_finale=="DQ"]<-"Active viewer"
sequence_finale2[sequence_finale=="AQV" | sequence_finale=="ADQ" |sequence_finale=="ADQV"]<-"Completer"
sequence_finale2[sequence_finale=="AV" | sequence_finale=="AD" |sequence_finale=="ADV" |sequence_finale=="AQ"]<-"Low completer"

sequence_finale2[sequence_finale=="I"]<-"Inactive"
colnames(sequence_finale2)<-c("Registrant",colnames(week_course))
if(vision=="temp"){user_temp<-unique(sequence_finale2$Registrant)} #A FAIRE AU MOMENT DU TEMPOREL
if(vision=="mod"){sequence_finale2<-sequence_finale2[sequence_finale2$Registrant %in% user_temp,]}

if(vision=="temp"){save.image(paste0(mooc,"_seq_temp.RData"))}
#load(paste0(mooc,"_seq_temp.RData"))

sapply(sequence_finale2[, grep("week", colnames(sequence_finale2))], table)
# prop.etat gives by week/section the proportion of each states
prop.etat<-as.data.frame(matrix(NA,9,9))
colnames(prop.etat)<-c("Week","Viewer","Collector","Quizzer","Active viewer","Completer","Low completer","Solver","Inactive")
prop.etat$Week<-colnames(week_course)
for(w in colnames(sequence_finale2[, grep("week", colnames(sequence_finale2))])){
  print(w)
  a<-round(100*prop.table(table(sequence_finale2[,w])),2)
  for (s in names(a)){
    prop.etat[prop.etat$Week==w,s]<-a[s]
  }
}
prop.etat$Week<-week_course[1,]

#proportion des états par semaine
write.csv(prop.etat,paste0(out,"seq 8 etats/",vision,"/prop etats.csv"))



# refaire sur vision="mod" le cas échéant


####### Re TraMineR sur sequence_finale2 #####

###########################
# I. Creation des data ####
###########################

# 8 états
seqstatl(sequence_finale2[,2:ncol(sequence_finale2)])
w.alphabet<-c("Viewer","Collector","Quizzer","Active viewer","Completer","Low completer","Solver","Inactive")
w.labels<-c("Viewer","Collector","Quizzer","Active viewer","Completer","Low completer","Solver","Inactive")
w.scodes<-c("V","Col","Q","AV","Comp","LComp","S","I")
w.seq <- seqdef(sequence_finale2, 2:ncol(sequence_finale2), alphabet = w.alphabet, states = w.scodes,labels = w.labels, xtstep = 8, cnames=week_course[1,],cpal=c("firebrick1","chocolate1","cyan","black","darkorchid1","gold","deeppink","aliceblue"))
# Active viewer = noir ; collector = orange ; completer = violet ; Inactive = blanc; low completer = jaune ; quizzer = bleu ;  solver = rose ; viewer = rouge


###########################
# II. Visualisation #######
###########################

par(mfrow = c(1, 1))
#Plot the legend for the state colors.
png(paste0(out,"seq 8 etats/",vision,"/legend.png"),temp.width,temp.height, pointsize = 15)
seqlegend(w.seq, fontsize=1) # assignment = vert ; download = orange ; Inactive = bleu clair ; quiz = violet ; view = rouge
dev.off()

#Plot the first 10 sequences in the mvad.seq sequence object.
seqiplot(w.seq, withlegend = "right", border = NA)

#Plot all the sequences in the data set, sorted by states from start.
png(paste0(out,"seq 8 etats/",vision,"/tapis.png"),temp.width,temp.height, pointsize = 30)
seqIplot(w.seq, sortv = "from.end", axes = F,yaxis=F,ylab=paste0("N = ",dim(w.seq)[1]),withlegend = F)# , title="MOOC activity" from.start
axis(2, at=seq(0,round(nrow(w.seq),-3),500),las=1,cex.axis=0.75)
ifelse(vision=="temp",axis(1, at=c(1:ncol(week_course))-.5, labels=week_course[1,],las=2,cex.axis=0.75),axis(1, at=c(1:ncol(week_course))-.5, labels=sections$title2[1:ncol(week_course)],las=2,cex.axis=0.75))
dev.off()

#Plot the most frequent 10 sequences.
seqfplot(w.seq, withlegend = FALSE, border = NA)


###########################
# III. Describe ###########
###########################
# Compute and plot the state distributions by time points. 
# Borders surrounding the bars are removed for nicer output. 
png(paste0(out,"seq 8 etats/",vision,"/prop states by week.png"),temp.width,temp.height, pointsize = 15)
seqdplot(w.seq,, border = NA, axes = F,withlegend = F,cex.legend=0.45)# , title="MOOC activity"
ifelse(vision=="temp",axis(1, at=c(1:ncol(week_course))-.5, labels=week_course[1,],las=2,cex.axis=0.75),axis(1, at=c(1:ncol(week_course))-.5, labels=sections$title2[1:ncol(week_course)],las=2,cex.axis=0.75))
dev.off()
#Compute and plot the transversal entropy index (sequence of entropies of the transversal state distributions).
seqHtplot(w.seq)

#Plot the sequence of modal states of the transversal state distributions.
seqmsplot(w.seq, withlegend = FALSE, border = NA, title="MOOC activity")

#Plot the mean time spent in each state of the alphabet.
seqmtplot(w.seq, withlegend = F, title="MOOC activity")

# proba de transitions
transition<-list()
for (i in 1:ncol(week_course)){
  transition[[i]]<-round(100*seqtrate(w.seq,time.varying=T),2)[,,i]
}
names(transition)<-week_course[1,1:(ncol(week_course)-1)]

#round(100*seqtrate(w.seq,time.varying=F),2)


#########################
### IV. TYPOLOGY ########
#########################

# 1.Compute the optimal matching distances using substitution costs based on transition rates
# observed in the data and a 1 indel cost. The resulting distance matrix is stored in the dist.om1 object.
dist.om1 <- seqdist(w.seq, method = "OM", indel = 1, sm = "TRATE",with.missing=TRUE)
#dist.om1 <- seqdist(w.seq, method = "OM", indel = 1, sm = "CONSTANT",with.missing=TRUE)


# 2.Make a typology of the trajectories: load the cluster library, build a Ward hierarchical clustering 
# of the sequences from the optimal matching distances and retrieve for each individual sequence 
# the cluster membership of the 4 class solution. We do not show here the dendrogram produced 
# by plot(clusterward1), which, indeed, is not a TraMineR feature.
library(cluster)

clusterward1 <- agnes(dist.om1, diss = TRUE, method = "ward")
# save.image("test.RData")
# load("test.RData")
#plot(clusterward1, which.plot = 2)
plot(sort(clusterward1$height, decreasing=TRUE)[1:10], type='s', xlab="nb de classes", ylab="inertie")
#s'il y a un grand saut, alors il est intéressant de regarder ce nb de classes
#algoprog_001 : temp 3,6 ; mod 3,5
#algoprog_002 : temp 4,6 et 10 ; mod 3 et 7
vect_nb_classe<-c(3,6) #a la main
for (i in vect_nb_classe){
  nb_classe<-i
  nb_classe<-3
  cl1.4 <- cutree(clusterward1, k = nb_classe)
  cl1.4fac <- factor(cl1.4, labels = paste("Type", 1:nb_classe))
  
  # 3.Plot all the sequences within each cluster.
  png(paste0(out,"seq 8 etats/",vision,"/",nb_classe,"classes.png"),temp.width,temp.height, pointsize = 25)
  par(mfrow = c(2,round2(nb_classe/2,0)))# par(mar=c(1,1,1,1)) #plot en carré
  #par(mfrow = c(1,nb_classe))# par(mar=c(1,1,1,1)) #plot à l'horizontale
  #par(mfrow = c(nb_classe,1))# par(mar=c(1,1,1,1)) #plot à la verticale
  # seqIplot(w.seq, group = cl1.4fac, sortv = "from.start", title="MOOC activity")
  for (j in 1:nb_classe){
    type<- paste("Type", j)
    om.4 <- dist.om1[which(cl1.4fac==type), which(cl1.4fac==type)]
    seqIplot(w.seq[which(cl1.4fac==type),], sortv = cmdscale(as.dist(om.4),k=1),ylab=paste0("N = ",dim(w.seq[which(cl1.4fac==type),])[1]), axes = F,yaxis=F,withlegend = F,cex.legend=0.45, title=paste0("MOOC activity - ",type," (N = ",dim(w.seq[which(cl1.4fac==type),])[1],")"))
    #axis(2, at=seq(0,round(nrow(w.seq[which(cl1.4fac==type),]),-1),round(nrow(w.seq[which(cl1.4fac==type),]),-1)/10),las=2,cex.axis=0.9)
    ifelse(vision=="temp",axis(1, at=c(1:ncol(week_course))-.5, labels=week_course[1,],las=2,cex.axis=0.8),axis(1, at=c(1:ncol(week_course))-.5, labels=sections$title2[1:ncol(week_course)],las=2,cex.axis=0.8))
  }
  dev.off()
}

par(mfrow = c(1,1))
#seqIplot(w.seq, group = cl1.4fac, sortv = cmdscale(as.dist(dist.om1),k=1), title="MOOC activity")


# etudier 1 seule classe
par(mfrow = c(1, 1))
om.4 <- dist.om1[which(cl1.4fac=="Type 4"), which(cl1.4fac=="Type 4")]
seqIplot(w.seq[which(cl1.4fac=="Type 4"),], sortv = cmdscale(as.dist(om.4),k=1), title="MOOC activity")



# 4.Plot the state distribution within each cluster.
seqdplot(w.seq, group = cl1.4fac, border = NA, title=paste("Semaine",num_week))

# 5. Entropie des classes
seqHtplot(w.seq, group=w.seq$"week 1", xtlab=1:9, withlegend=T)

# 6.Plot the representative sequences of each cluster.
seqrplot(w.seq, dist.matrix = dist.om1, group = cl1.4fac,border = NA, title="Representative sequences of each cluster")
# savePlot(paste("out/sequence/","Week ",num_week,": representative sequecences of each cluster",sep=""),type="png")
# png(paste("out/sequence/","Week ",num_week,": representative sequecences of each cluster.png",sep=""),width=12,height=8)

# Distribution des classes
distri.eff <- table(cl1.4fac)
distri.eff
round(distri.eff/sum(distri.eff)*100,1)

